#!/bin/sh

run_test () {
  query="$1"
  for i in 0 1 0 1 0 1; do
    service postgresql restart
    sync; echo 3 > /proc/sys/vm/drop_caches; sleep 5
    psql testdb -e -c "set effective_io_concurrency=$i; set enable_indexscan=off; set enable_seqscan=off; explain (analyze, buffers)  $query;"
  done
}

createdb testdb

psql testdb -e -c "create table test as select generate_series(1, 100000) id, repeat('x', 90) val;"
psql testdb -e -c "alter table test add constraint test_pkey primary key (id);"

run_test "select * from test where id between 0 and 100000 and val != ''" >test01.txt
run_test "select * from test where id between 10 and 100000 and val != ''" >test02.txt
run_test "select * from test where id between 50 and 100000 and val != ''" >test03.txt
run_test "select * from test where id between 64 and 100000 and val != ''" >test04.txt
run_test "select * from test where id between 65 and 100000 and val != ''" >test05.txt
run_test "select * from test where id between 66 and 100000 and val != ''" >test06.txt
run_test "select * from test where id between 100 and 100000 and val != ''" >test07.txt
run_test "select * from test where id between 200 and 100000 and val != ''" >test08.txt
run_test "select * from test where id between 1000 and 100000 and val != ''" >test09.txt
run_test "select * from test where id between 2000 and 100000 and val != ''" >test10.txt
run_test "select * from test where id between 5000 and 100000 and val != ''" >test11.txt
run_test "select * from test where id between 10000 and 100000 and val != ''" >test12.txt
run_test "select * from test where id between 20000 and 100000 and val != ''" >test13.txt
run_test "select * from test where id between 50000 and 100000 and val != ''" >test14.txt
run_test "select * from test where id between 75000 and 100000 and val != ''" >test15.txt
run_test "select * from test where id between 90000 and 100000 and val != ''" >test16.txt

echo "" > summary.txt

psql testdb -e -c "select count(*) tup_per_page from test group by (ctid::text::point)[0] order by count(*) desc limit 5;" >>summary.txt

cat test01.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test02.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test03.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test04.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test05.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test06.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test07.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test08.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test09.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test10.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test11.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test12.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test13.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test14.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test15.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt
cat test16.txt | grep -E "effective_io_concurrency|Execution time" | perl -p -e 's/.*(effective_io_concurrency=[0-9]+).*(id between [0-9]+ and [0-9]+).*\n/\1; \2;/' >>summary.txt; echo "" >>summary.txt

dropdb testdb
